%%% ==== This is to perform a classification based on a given feature
%%% vector Mzs. 
%%% Input:
%%%         1. Feature vector Mzs (from SAM analysis)
%%%         2. X: Molecular Data with one patient exluded during training
%%%         3. Test: Molecular data of the excluded patient (unseen
%%%         patient)
%%% Output:
%%%         1.Percentage_TestLabels: represents the percentage of existence
%%%         of certain subpopulations for this unseen patient
%%% =======================================================================
N_Patients = length(Clinical_data);
Counter_i = 0;

for PatientID= 1:N_Patients
clear X
PatientID

Index_PatientSubPopulation = find(pixel_to_sample_ID(goodlist>0)==PatientID);

for i=1:length(Mzs)
ij = find (peak_list(:,1) ==Mzs(i)); % coloring by mz
X(:,i) = Tumors_All(:,ij); 
end


Test = X(Index_PatientSubPopulation,:);
X(Index_PatientSubPopulation,:) = [];
Train = X;
% Labels
Labels = NewLabels_IDXs;
Test_Labels = Labels(Index_PatientSubPopulation,:);
Labels(Index_PatientSubPopulation,:) = [];
Train_Labels = Labels;

% KNN Classifier
NBModel = ClassificationKNN.fit(Train,Train_Labels,'NumNeighbors',5);
rloss = resubLoss(NBModel);
TestClass = predict(NBModel,Test);

Labels_Unique = unique(NewLabels_IDXs);
nLabels = length(Labels_Unique);
Percentage_TestLabels = [];
for L_ID=1:nLabels
Label_1 = 100*(length(find(TestClass==Labels_Unique(L_ID)))./size(TestClass,1));
Percentage_TestLabels = [Percentage_TestLabels,Label_1];
end
Percentage_TestLabels
Percentage_TestLabels_ALL(PatientID,:) = Percentage_TestLabels;

end
